package com.jiuqi.sql;

import java.io.IOException;
import java.io.Reader;

/* loaded from: com_jiuqi_sql.jar:com/jiuqi/sql/SQLScriptExcutor.class */
public abstract class SQLScriptExcutor {
    private Reader reader;
    private boolean isIgnoreComment;
    private boolean isString;
    private boolean isBlockComment;
    private boolean isLineComment;
    private StringBuffer sql = new StringBuffer();
    private StringBuffer line = new StringBuffer();

    protected abstract void excuteSingleSql(String str) throws DBException;

    public SQLScriptExcutor(Reader sqlReader, boolean isIgnoreComment) {
        this.reader = sqlReader;
        this.isIgnoreComment = isIgnoreComment;
    }

    public final void parse() throws IOException, DBException {
        char c;
        while (true) {
            int i = this.reader.read();
            if (i != -1) {
                char c2 = (char) i;
                if (c2 == '\r' || c2 == '\n') {
                    if (this.line.length() != 0) {
                        this.sql.append(this.line.toString());
                        this.sql.append("\r\n");
                        this.line.setLength(0);
                    }
                    this.isLineComment = false;
                } else if (!this.isLineComment) {
                    if (this.isBlockComment && this.isIgnoreComment) {
                        if (c2 == '*' && (c = (char) this.reader.read()) != 65535 && c == '/') {
                            this.isBlockComment = false;
                        }
                    } else {
                        switch (c2) {
                            case '\'':
                                this.line.append(c2);
                                if (!this.isBlockComment) {
                                    this.isString = !this.isString;
                                    break;
                                } else {
                                    break;
                                }
                            case '*':
                                if (this.isBlockComment) {
                                    char c3 = (char) this.reader.read();
                                    if (c3 != 65535) {
                                        if (c3 == '/') {
                                            this.isBlockComment = false;
                                        }
                                        if (!this.isIgnoreComment) {
                                            this.line.append('*').append(c3);
                                            break;
                                        } else {
                                            break;
                                        }
                                    } else {
                                        break;
                                    }
                                } else {
                                    this.line.append('*');
                                    break;
                                }
                            case '-':
                                if (!this.isBlockComment && !this.isString) {
                                    char c4 = (char) this.reader.read();
                                    if (c4 == '-') {
                                        this.isLineComment = true;
                                        break;
                                    } else {
                                        this.line.append('-').append(c4);
                                        break;
                                    }
                                } else {
                                    this.line.append('-');
                                    break;
                                }
                            case '/':
                                if (!this.isBlockComment && !this.isString) {
                                    int i2 = this.reader.read();
                                    char c5 = (char) i2;
                                    if (i2 != -1) {
                                        if (c5 == '*') {
                                            this.isBlockComment = true;
                                            if (!this.isIgnoreComment) {
                                                this.line.append('/').append(c5);
                                                break;
                                            } else {
                                                break;
                                            }
                                        } else {
                                            this.line.append('/').append(c5);
                                            break;
                                        }
                                    } else {
                                        break;
                                    }
                                } else {
                                    this.line.append('/');
                                    break;
                                }
                            case ';':
                                if (!this.isBlockComment && !this.isString) {
                                    excute();
                                    break;
                                } else {
                                    this.line.append(';');
                                    break;
                                }
                                break;
                            case 'G':
                                if (!this.isBlockComment && !this.isString) {
                                    char c6 = (char) this.reader.read();
                                    if (c6 == 'O' || c6 == 'o') {
                                        char nextChar = (char) this.reader.read();
                                        if (nextChar == '\r' || nextChar == '\n') {
                                            excute();
                                            break;
                                        } else {
                                            this.line.append('G').append(c6).append(nextChar);
                                            break;
                                        }
                                    } else {
                                        this.line.append('G').append(c6);
                                        break;
                                    }
                                } else {
                                    this.line.append('G');
                                    break;
                                }
                                break;
                            case 'g':
                                if (!this.isBlockComment && !this.isString) {
                                    char c7 = (char) this.reader.read();
                                    if (c7 == 'O' || c7 == 'o') {
                                        char nextChar2 = (char) this.reader.read();
                                        if (nextChar2 == '\r' || nextChar2 == '\n') {
                                            excute();
                                            break;
                                        } else {
                                            this.line.append('g').append(c7).append(nextChar2);
                                            break;
                                        }
                                    } else {
                                        this.line.append('g').append(c7);
                                        break;
                                    }
                                } else {
                                    this.line.append('g');
                                    break;
                                }
                                break;
                            default:
                                this.line.append(c2);
                                break;
                        }
                    }
                }
            } else {
                excute();
                return;
            }
        }
    }

    public boolean isIgnoreComment() {
        return this.isIgnoreComment;
    }

    private void excute() throws DBException {
        this.sql.append(this.line.toString());
        if (this.sql.length() != 0) {
            excuteSingleSql(this.sql.toString());
        }
        this.line.setLength(0);
        this.sql.setLength(0);
    }
}
